Server-side Call Home on SSH
Server » Server-side Call Home

SSH settings for the Call Home functionality. More...

Collaboration diagram for Server-side Call Home on SSH:

## Functions

int | nc_server_ssh_ch_client_endpt_add_hostkey (const char *client_name, const char *endpt_name, const char *name, int16_t idx)
| Add Call Home SSH host keys the server will identify itself with. Only the name is set, the key itself wil be retrieved using a callback. More...
int | nc_server_ssh_ch_client_endpt_del_hostkey (const char *client_name, const char *endpt_name, const char *name, int16_t idx)
| Delete Call Home SSH host keys. Their order is preserved. More...
int | nc_server_ssh_ch_client_endpt_get_auth_methods (const char *client_name, const char *endpt_name)
| Get accepted Call Home SSH authentication methods. More...
int | nc_server_ssh_ch_client_endpt_mov_hostkey (const char *client_name, const char *endpt_name, const char *key_mov, const char *key_after)
| Move Call Home SSH host key. More...
int | nc_server_ssh_ch_client_endpt_set_auth_attempts (const char *client_name, const char *endpt_name, uint16_t auth_attempts)
| Set Call Home SSH authentication attempts of every client. 3 by default. More...
int | nc_server_ssh_ch_client_endpt_set_auth_methods (const char *client_name, const char *endpt_name, int auth_methods)
| Set accepted Call Home SSH authentication methods. All (publickey, password, interactive) are supported by default. More...
int | nc_server_ssh_ch_client_endpt_set_auth_timeout (const char *client_name, const char *endpt_name, uint16_t auth_timeout)
| Set Call Home SSH authentication timeout. 30 seconds by default. More...

## Detailed Description

SSH settings for the Call Home functionality.

## Function Documentation

## nc_server_ssh_ch_client_endpt_add_hostkey()

int nc_server_ssh_ch_client_endpt_add_hostkey | ( | const char * | client_name,
|  | const char * | endpt_name,
|  | const char * | name,
|  | int16_t | idx
| ) |  |

Add Call Home SSH host keys the server will identify itself with. Only the name is set, the key itself wil be retrieved using a callback.

Parameters

  [in] | client_name | Existing Call Home client name.
  [in] | endpt_name | Existing endpoint name of the client.
  [in] | name | Arbitrary name of the host key.
  [in] | idx | Optional index where to add the key. -1 adds at the end.

Returns
  0 on success, -1 on error.

## nc_server_ssh_ch_client_endpt_del_hostkey()

int nc_server_ssh_ch_client_endpt_del_hostkey | ( | const char * | client_name,
|  | const char * | endpt_name,
|  | const char * | name,
|  | int16_t | idx
| ) |  |

Delete Call Home SSH host keys. Their order is preserved.

Parameters

  [in] | client_name | Existing Call Home client name.
  [in] | endpt_name | Existing endpoint name of the client.
  [in] | name | Name of the host key. NULL matches all the keys, but if `idx` != -1 then this must be NULL.
  [in] | idx | Index of the hostkey. -1 matches all indices, but if `name` != NULL then this must be -1.

Returns
  0 on success, -1 on error.

## nc_server_ssh_ch_client_endpt_get_auth_methods()

int nc_server_ssh_ch_client_endpt_get_auth_methods | ( | const char * | client_name,
|  | const char * | endpt_name
| ) |  |

Get accepted Call Home SSH authentication methods.

Parameters

  [in] | client_name | Existing Call Home client name.
  [in] | endpt_name | Existing endpoint name of the client.

Returns
  Accepted authentication methods bit field of NC_SSH_AUTH_TYPE.

## nc_server_ssh_ch_client_endpt_mov_hostkey()

int nc_server_ssh_ch_client_endpt_mov_hostkey | ( | const char * | client_name,
|  | const char * | endpt_name,
|  | const char * | key_mov,
|  | const char * | key_after
| ) |  |

Move Call Home SSH host key.

Parameters

  [in] | client_name | Exisitng Call Home client name.
  [in] | endpt_name | Existing endpoint name of the client.
  [in] | key_mov | Name of the host key that will be moved.
  [in] | key_after | Name of the key that will preceed `key_mov`. NULL if `key_mov` is to be moved at the beginning.

Returns
  0 in success, -1 on error.

## nc_server_ssh_ch_client_endpt_set_auth_attempts()

int nc_server_ssh_ch_client_endpt_set_auth_attempts | ( | const char * | client_name,
|  | const char * | endpt_name,
|  | uint16_t | auth_attempts
| ) |  |

Set Call Home SSH authentication attempts of every client. 3 by default.

Parameters

  [in] | client_name | Existing Call Home client name.
  [in] | endpt_name | Existing endpoint name of the client.
  [in] | auth_attempts | Failed authentication attempts before a client is dropped.

Returns
  0 on success, -1 on error.

## nc_server_ssh_ch_client_endpt_set_auth_methods()

int nc_server_ssh_ch_client_endpt_set_auth_methods | ( | const char * | client_name,
|  | const char * | endpt_name,
|  | int | auth_methods
| ) |  |

Set accepted Call Home SSH authentication methods. All (publickey, password, interactive) are supported by default.

Parameters

  [in] | client_name | Existing Call Home client name.
  [in] | endpt_name | Existing endpoint name of the client.
  [in] | auth_methods | Accepted authentication methods bit field of NC_SSH_AUTH_TYPE.

Returns
  0 on success, -1 on error.

## nc_server_ssh_ch_client_endpt_set_auth_timeout()

int nc_server_ssh_ch_client_endpt_set_auth_timeout | ( | const char * | client_name,
|  | const char * | endpt_name,
|  | uint16_t | auth_timeout
| ) |  |

Set Call Home SSH authentication timeout. 30 seconds by default.

Parameters

  [in] | client_name | Existing Call Home client name.
  [in] | endpt_name | Existing endpoint name of the client.
  [in] | auth_timeout | Number of seconds before an unauthenticated client is dropped.

Returns
  0 on success, -1 on error.